;
; AutoHotkey Version: 1.x
; Language:       English
; Platform:       Win9x/NT
; Author:         A.N.Other <myemail@nowhere.com>
;
; Script Function:
;	Template script (you can customize this template by editing "ShellNew\Template.ahk" in your Windows folder)
;

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

Menu, Tray, Add,Set Reminder,SetReminder

IfExist, C:\Users\%A_UserName%\Reminder\Reminder.ini
  {
    GoSub, ReadIni
    If(RemTime > A_Now)
      {
        MyTime := RemTime
	MyNote := RemMemo

        GoSub, ButtonSubmit
	
      }
     Else
      {
        MyTime := A_Now
	MyNote := "Remind Me!"
      }
  }

IfNotExist, C:\Users\%A_UserName%\Reminder\
    FileCreateDir, C:\Users\%A_UserName%\Reminder\

Hotkey, ^#R, SetReminder, On

Return

SetReminder:

HotKey, ^#R, Off
Menu, Tray, Disable, Set Reminder

Gui, Font, s12, Arial
Gui, Add, Text,, 1. Select time`n2. Add note`n3. Submit`n4. Close popup
Gui, Add, DateTime, vMyTime w350 1 Range%A_Now% Choose%MyTime%,dddd,MMMMd,  yyyy hh:mm tt
Gui, Add, Edit, vMyNote w350, %MyNote%
Gui, Add, Button, Default, Submit
Gui, Show,  , Reminder
Return

ButtonSubmit:
Gui, Submit, NoHide
NewTime := MyTime

If (MyTime > A_Now)
  {
    EnvSub, NewTime, A_Now, s

    FormatTime, Schedule, %MyTime%
    MsgBox,4160,Your Reminder, "%MyNote%" is scheduled for`n%Schedule%

    #Persistent
    RemMessage := "Better get going!"
    GoSub, WriteIni
    SetTimer, ShowReminder, % NewTime*1000
  }
Else
  {
    MsgBox, The time must be later than right now!
    GuiControl,,MyTime, %A_Now%
  }

Return

GuiClose:
  Gui, Destroy
  HotKey, ^#R, On
  Menu, Tray, Enable, Set Reminder
Return

ShowReminder:
FormatTime, RightNow
#persistent

IfExist, %A_WinDir%\nircmd.exe
  {
   SetTimer, TalkToMe, 15000
  }

Hotkey, IfWinActive, Your Reminder!
Hotkey, Esc, StopEscape

SetTimer, ChangeButtonNames, 50 
MsgBox,20800,Your Reminder!, %MyNote% `n%Rightnow%
MyNote := "New Reminder!"
SetTimer, ShowReminder, Off
 
IfMsgBox, OK
   SetTimer, TalkToMe, Off
   Hotkey, IfWinActive
return

ChangeButtonNames: 
  IfWinNotExist, Your Reminder!
    return  ; Keep waiting.
  SetTimer, ChangeButtonNames, off 
  WinActivate 
  ControlSetText, Button2, Waiting,Your Reminder!
return

TalkToMe:
run, nircmd.exe speak text "%MyNote%"
Return

StopEscape:
  Return

WriteIni:
	IniWrite, %MyTime%, C:\Users\%A_UserName%\Reminder\Reminder.ini, Settings, Time
	IniWrite, %MyNote%, C:\Users\%A_UserName%\Reminder\Reminder.ini, Settings, Memo
Return

ReadIni:
	IniRead, RemTime, C:\Users\%A_UserName%\Reminder\Reminder.ini, Settings, Time
	IniRead, RemMemo, C:\Users\%A_UserName%\Reminder\Reminder.ini, Settings, Memo
Return


